bs.boot = function () {
  var self = this;


  document.addEventListener("deviceready", function () {
    if (navigator.userAgent.match(/Android/i))
      bs.device = 'android';
    else
      bs.device = 'ios';

    // admob stuff
    var bannerAdUnit = "ca-app-pub-xxx";
    var interstitialAdUnit;
    var isOverlap = true; //true: overlap, false: split
    var isTest = false;

    if (window.admob) {
      if (bs.device == 'android')
        interstitialAdUnit = "ca-app-pub-8516712240494280/6712362617";
      else
        interstitialAdUnit = "ca-app-pub-8516712240494280/1701910219";

      window.admob.setUp(bannerAdUnit, interstitialAdUnit, isOverlap, isTest);
      window.admob.onInterstitialAdHidden = function () {
        window.admob.preloadInterstitialAd();

      };
      // prime the ad
      //window.admob.preloadInterstitialAd();
    }

    if (window.powerManagement) {
      window.powerManagement.acquire();
      // background

      document.addEventListener("pause", function () {
        window.powerManagement.release();
      }, false);

      document.addEventListener("resume", function () {
        window.powerManagement.acquire();
      }, false);
    }

    if (!window.store) {
      console.log('store not available');
    } else {
      // Enable maximum logging level
      //store.verbosity = store.DEBUG;

      // Inform the store of your products
      //console.log('registerProducts');
      store.register({
        id: 'bs_remove_ads', // id without package name!
        type: store.NON_CONSUMABLE
      });

      store.when("bs_remove_ads").approved(function (order) {
        //console.log('You just removed ads!');
        order.finish();
      });

      store.when("bs_remove_ads").updated(function (p) {
        bs.ads_on = !p.owned;
        bs.ads_price = p.price;
        //console.log(p);

        // prime the ad
        if (bs.ads_on && window.admob)
          window.admob.preloadInterstitialAd();

      });

      // Log all errors
      store.error(function (error) {
        console.log('ERROR ' + error.code + ': ' + error.message);
      });

      store.refresh();

    }

  }, false);


  self.create = function () {
    // cordova plugin and ad related related setup...

    bs.platform = (/(android)/i.test(navigator.userAgent)) ? 'android' : 'ios';

    bs.svrbase = "http://todoosh.com/ds/";

    bs.siglr = new siglr();


    // Phaser boot stuff

    // set scale options
    self.input.maxPointers = 1;
    self.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
    self.scale.pageAlignHorizontally = true;
    self.scale.pageAlignVertically = true;
    self.scale.setScreenSize(true);

    self.state.start('preloader');
  }

}
