bs.tsize = 43;
bs.activeBox = new Phaser.Rectangle(0, bs.tsize * 2, bs.tsize * 10, bs.tsize * 10);
bs.totalPegs = 100;
bs.isTwoPlay = false;

bs.ads_on = bs.animOn = bs.audioOn = true;


// return x y from pointer to
// position on array 0 - 99
bs.getPosFromXY = function (x, y) {
    var r = c = 0;
    var xx = x - (bs.tsize * 0.5);
    var yy = y - (bs.tsize * 2.5);

    if (xx > 0)
      c = xx / bs.tsize;
    if (yy > 0)
      r = yy / bs.tsize;

    return (r * 10) + c;

  }
  // get x y coordinates from array pos
bs.getXYFromPos = function (pos) {
  var r = Math.floor(pos / 10);
  var c = pos % 10;
  var x = (bs.tsize * c) + (bs.tsize * 0.5);
  var y = (bs.tsize * r) + (bs.tsize * 2.5);

  return {
    x: x,
    y: y
  };

}

bs.setHeader = function (text) {
  bs.setText(text, bs.game.world.centerX, 40, 32, 4, 'LightSteelBlue', 'DarkSlateGray');
}

bs.setText = function (text, x, y, sz, sk, g1, g2) {
  var self = this;
  self.text = bs.game.add.text();
  self.text.x = x;
  self.text.y = y;
  self.text.text = text;
  self.text.anchor.set(0.5, 0.5);
  self.text.font = 'courier';
  self.text.align = 'center';
  self.text.fontWeight = 'bold';
  self.text.fontSize = sz;
  self.text.stroke = 'black';
  self.text.strokeThickness = sk;
  self.text.wordWrap = true;
  self.text.wordWrapWidth = bs.game.world.width - 20;
  self.text.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);

  var grd = self.text.context.createLinearGradient(0, 0, 0, self.text.height);
  grd.addColorStop(0, g1);
  grd.addColorStop(1, g2);
  self.text.fill = grd;

  return self.text;
}

bs.getOptions = function (y, audarry, anmarry) {

  var click02 = bs.game.add.audio('click02');
  var $phaser_game = $('#phaser_game');
  var $opts_pane = $('#opts_pane');
  var $goback_butt = $('#goback_butt', $opts_pane);
  var $gohome_butt = $('#gohome_butt', $opts_pane);
  var $audon_cb = $('#audon_cb', $opts_pane);
  var $anion_cb = $('#anion_cb', $opts_pane);
  var $iap_butt = $('#iap_butt', $opts_pane);

  $audon_cb.prop( "checked", bs.audioOn );
  $anion_cb.prop( "checked", bs.animOn );

  if(bs.ads_on)
    $iap_butt.text('Turn Ads off for '+bs.ads_price);
  else
    $iap_butt.hide();

  $audon_cb.bootstrapSwitch();
  $anion_cb.bootstrapSwitch();

  $audon_cb.on('switchChange.bootstrapSwitch', function(event, state) {
    bs.audioOn = state;
    if (audarry)
      if (bs.audioOn)
        for (var i = 0; i < audarry.length; i++)
          audarry[i].play();
      else
        for (var i = 0; i < audarry.length; i++)
          audarry[i].stop();

  });
  $anion_cb.on('switchChange.bootstrapSwitch', function(event, state) {
    bs.animOn = state;
    if (audarry)
      if (bs.audioOn)
        for (var i = 0; i < audarry.length; i++)
          audarry[i].play();
      else
        for (var i = 0; i < audarry.length; i++)
          audarry[i].stop();
  });

  // mute button
  var gearbtn = bs.game.add.button(bs.game.width - 20, 20, 'gearbtn',
    function () {
      click02.play();
      $phaser_game.hide();
      $opts_pane.show();

    }, this, 0, 0, 0, 0);

  gearbtn.anchor.setTo(0.5, 0.5);
  if (bs.animOn)
    bs.game.add.tween(gearbtn).to({angle:'+180'}, 1000, Phaser.Easing.Cubic.Out, true);

  $goback_butt.on('click', function () {
    if (bs.audioOn)
      click02.play();
    $phaser_game.show();
    $opts_pane.hide();
    if (bs.animOn)
      bs.game.add.tween(gearbtn).to({angle:'+180'}, 1000, Phaser.Easing.Cubic.Out, true);

  });

   $gohome_butt.on('click', function () {
     if (bs.audioOn)
      click02.play();
    $phaser_game.show();
    $opts_pane.hide();
    bs.game.state.start('menu');
   });

   $iap_butt.on('click', function () {
     if (bs.audioOn)
       click02.play();
       if (!bs.ads_on){
         bootbox.alert('You have already removed ads from this game. Enjoy!');
       }else{
         store.order('bs_remove_ads');
       }
   });

}

function shipObj(name, w, sheet, aframes) {

  var self = this;

  // game data...
  self.width = w; // cell width
  self.locs = []; // locations on the board {pos:0,hit:false}
  self.orien = 'h' // 'v' or 'h'
  self.sheet = sheet;
  self.name = name;
  self.isSunk = false;

  self.ready = false;

  self.aframes = aframes;

  self.even = self.width % 2 == 0

  self.setSprite = function (x, y, input, pivot) {

      self.sprite = bs.game.add.sprite(x, y, self.sheet);
      bs.game.physics.enable(self.sprite, Phaser.Physics.ARCADE);
      self.sprite.anchor.setTo(0.5, 0.5);

      if (input) {

        self.horzBox = new Phaser.Rectangle(
          bs.activeBox.x + Math.floor(w / 2) * bs.tsize,
          bs.activeBox.y,
          bs.activeBox.width,
          bs.activeBox.height + (3 * bs.tsize)
        );

        self.vertBox = new Phaser.Rectangle(
          bs.activeBox.x, // good
          bs.activeBox.y + Math.floor(w / 2) * bs.tsize, // good
          bs.activeBox.width + (Math.floor(w / 2) * bs.tsize) * 2, //good
          bs.activeBox.height + (3 * bs.tsize) - ((Math.floor(w / 2) * bs.tsize) * 2) //good
        );

        self.sprite.inputEnabled = true;
        self.sprite.input.enableDrag();
        self.sprite.input.lockCenter = true;
        self.sprite.input.enableSnap(bs.tsize, bs.tsize, true, true);

        if (!self.even)
          self.sprite.input.snapOffsetX = bs.tsize / 2;
        self.sprite.input.snapOffsetY = bs.tsize / 2;

        if (self.orien == 'h') {
          self.sprite.input.boundsRect = self.horzBox;
        } else {
          self.sprite.input.boundsRect = self.vertBox;
          self.sprite.angle += 90.0;
        }

        self.xx = 0;
        self.yy = 0;

        self.motor = bs.game.add.audio('boat');

        self.splash = bs.game.add.audio('slosh');

        self.clank = bs.game.add.audio('clank');

        self.sprite.events.onDragStart.add(function (s, p) {

          self.xx = p.x;
          self.yy = p.y;
          if (bs.audioOn)
            self.motor.play('', 0, 1, true);

        });

        self.sprite.events.onDragStop.add(function (s, p) {

          self.motor.stop();

          var xdif = Math.abs(self.xx - p.x);
          var ydif = Math.abs(self.yy - p.y);


          if (xdif < 5 && ydif < 5) {
            self.rotween.start();

          } else {
            if (self.tweek) {
              // minor adjustment needed for one ship
              // that is stored verticaly
              self.xx = s.x += bs.tsize / 2;
              self.yy = s.y -= bs.tsize / 2;
              s.input.snapOffsetX = bs.tsize / 2;
              s.input.snapOffsetY = 0;
              self.tweek = false;
            }
            if (bs.audioOn)
              if (self.ready)
                self.splash.play();
              else
                self.clank.play();
          }
        });

        self.rotween = bs.game.add.tween(self.sprite).to({
            angle: '+90'
          }, 500,
          Phaser.Easing.Cubic.In, false);

        self.rotween.onStart.add(function (s) {
          if (bs.audioOn)
            self.splash.play();
        });

        self.rotween.onComplete.add(function (s) {
          if (s.angle == 0.0 || s.angle == -180.0) {
            s.input.boundsRect = self.horzBox;
            self.orien = 'h';
          } else if (s.angle == 90.0 || s.angle == -90.0) {
            s.input.boundsRect = self.vertBox;
            self.orien = 'v';
          }
          if (s.y < s.input.boundsRect.y) { // top
            s.y += Math.floor(w / 2) * bs.tsize;
          } else if ((s.y + bs.tsize) > s.input.boundsRect.y + s.input.boundsRect.height) { // bottom
            result = Math.floor(w / 2) * bs.tsize;
            s.y -= Math.floor(w / 2) * bs.tsize;
          } else if (s.x < s.input.boundsRect.x) { // left
            s.x += Math.floor(w / 2) * bs.tsize;
          } else if (s.x > s.input.boundsRect.x + s.input.boundsRect.width - (w * bs.tsize)) { //right
            s.x -= Math.floor(w / 2) * bs.tsize;
          }

          // a ship that is even does not rotate correctly
          // need to be shifted
          if (self.even) {
            self.sprite.x += bs.tsize / 2;
            self.sprite.y += bs.tsize / 2;
            if (self.orien == 'h') {
              self.sprite.input.snapOffsetY = bs.tsize / 2;
              self.sprite.input.snapOffsetX = 0;
            } else {
              self.sprite.input.snapOffsetX = bs.tsize / 2;
              self.sprite.input.snapOffsetY = 0;
            }
          }
          if (!self.ready)
            if (bs.audioOn)
              self.clank.play();

        });

      }

      if (pivot) {
        // pivot is used to place ai ships
        self.sprite.pivot.x = -(self.sprite.width * .5) + bs.tsize / 2;
        self.sprite.pivot.y = -(self.sprite.height * .5) + bs.tsize / 2;

        if (self.orien == 'v') {
          self.sprite.angle = 90;
        }
      }


      self.sprite.animations.add('floating', self.aframes, 3, true);
      if (bs.animOn)
        self.sprite.animations.play('floating')
      self.sprite.animations.currentAnim.paused = true;

      self.animPause = function (pause) {
        if (pause && !self.sprite.animations.currentAnim.paused)
          self.sprite.animations.currentAnim.paused = true;
        else if (!pause && self.sprite.animations.currentAnim.paused)
          if (bs.animOn)
            self.sprite.animations.currentAnim.paused = false;
      }

    } // set sprite

  self.getFirstXY = function () {
    // need to find the position of the first hole
    // if odd holes then its the center hole - (width-1)/2
    // if even then center - 21.5 - width / 2 * 43
    var x = y = 0;
    var w = self.width;
    if (!self.even) // odd
      w--;

    if (self.orien == 'h') {
      x = self.sprite.x - ((w * 0.5) * bs.tsize);
      y = self.sprite.y;
      if (self.even)
        x += bs.tsize / 2;
    } else {
      x = self.sprite.x;
      y = self.sprite.y - ((w * 0.5) * bs.tsize);
      if (self.even)
        y += bs.tsize / 2;
    }
    return {
      x: x,
      y: y
    };
  }

}

function targetObj(x, y, hide, dropped) {
  var self = this;
  self.pos = bs.getPosFromXY(x, y);
  self.sprite = bs.game.add.sprite(x, y, 'crosshairs');
  self.sprite.visible = !hide;
  bs.game.physics.enable(self.sprite, Phaser.Physics.ARCADE);
  self.sprite.anchor.setTo(0.5, 0.5);
  self.sprite.scale.setTo(0.75, 0.75);
  self.sprite.inputEnabled = true;
  self.sprite.input.enableDrag();
  self.sprite.input.lockCenter = true;
  self.sprite.input.enableSnap(bs.tsize, bs.tsize, true, true);
  self.sprite.input.snapOffsetX = bs.tsize * 0.5;
  self.sprite.input.snapOffsetY = bs.tsize * 0.5;

  self.ready = false;

  // audio
  self.whirring = bs.game.add.audio('whirring');
  self.gear = bs.game.add.audio('gear01');
  self.clank = bs.game.add.audio('clank');

  self.deployed = false;

  self.sprite.input.boundsRect = new Phaser.Rectangle(
    bs.activeBox.x,
    bs.activeBox.y,
    bs.activeBox.width + (bs.tsize * 2),
    bs.activeBox.height + (5 * bs.tsize)
  );

  self.sprite.events.onDragStart.add(function (s, p) {
    if (bs.audioOn)
      self.whirring.play('', 0, 1, true);
  });

  self.sprite.events.onDragStop.add(function (s, p) {
    self.pos = bs.getPosFromXY(s.x, s.y);
    dropped();

    self.whirring.stop();
    if (bs.audioOn)
      if (self.ready)
        self.gear.play();
      else
        self.clank.play();

  });

}

function boardObj() {
  var self = this;

  // ships have state - hit/not hit
  self.ships = [];
  // misses exist or not
  self.misses = [];

  self.winner = false;

  self.placeShips = function (scale, offset, sunkOnly, animate) {
    if (!offset)
      offset = {
        x: 0,
        y: 0
      };

    for (var i = 0, l = self.ships.length; i < l; i++) {
      var ship = self.ships[i];

      if (ship.isSunk || (!sunkOnly)) {

        var loc = ship.locs[0];
        // if (!loc)
        //   return;

        var xy = bs.getXYFromPos(loc.pos)

        ship.setSprite(
          (ship.orien == 'v') ?
          xy.x + offset.x :
          xy.x - offset.x,
          xy.y + offset.y, false, true);

        if (scale)
          ship.sprite.scale.setTo(scale, scale);

        if (animate)
          ship.animPause(false);
      }
    }
  }

  self.freezeShips = function () {
    for (var i = 0, l = self.ships.length; i < l; i++) {
      var ship = self.ships[i];
      ship.sprite.inputEnabled = false;
      ship.sprite.animations.currentAnim.paused = true;
    }
  }

  self.placePegs = function (scale, offset) {
    if (!offset)
      offset = {
        x: 0,
        y: 0
      };

    for (var i = 0; i < self.ships.length; i++) {
      var ship = self.ships[i];
      for (var j = 0; j < ship.locs.length; j++) {
        var loc = ship.locs[j];
        if (loc.hit) {
          var xy = bs.getXYFromPos(loc.pos);
          var peg = new pegObj(xy.x + offset.x, xy.y + offset.y, true);
          if (scale)
            peg.sprite.scale.setTo(scale, scale);
        }
      }
    }

    for (var i = 0; i < self.misses.length; i++) {
      var miss = self.misses[i];
      var xy = bs.getXYFromPos(miss);
      var peg = new pegObj(xy.x + offset.x, xy.y + offset.y, false);
      if (scale)
        peg.sprite.scale.setTo(scale, scale);
    }
  }

  self.isHit = function (pos) {
    for (var i = 0; i < self.ships.length; i++) {
      var ship = self.ships[i];
      for (var j = 0; j < ship.locs.length; j++) {
        var loc = ship.locs[j];
        if (pos == loc.pos && loc.hit) {
          return true;
        }
      }
    }
    return false;
  }

  self.isMiss = function (pos) {
    for (var i = 0; i < self.misses.length; i++) {
      var miss = self.misses[i];
      if (pos == miss) {
        return true;
      }
    }
    // off the board is considered a miss
    return (pos >= bs.totalPegs || pos < -1);

  }

  self.isOccupied = function (pos) {
    if (self.isHit(pos))
      return true;

    if (self.isMiss(pos))
      return true;

    return false;
  }

  self.checkWinner = function (fake) {

    if (fake)
      return true;

    for (var i = 0; i < self.ships.length; i++) {
      var ship = self.ships[i];
      for (var j = 0; j < ship.locs.length; j++) {
        var loc = ship.locs[j];
        if (!loc.hit) {
          return false;
        }
      }
    }

    return true;

  }

  return false;
}

function playObj() {
  var self = this;

  self.youBoard = new boardObj();
  self.oppBoard = new boardObj();
  self.ai = new aiObj();

  // flip a coin
  self.yourturn = (Math.round(Math.random()) == 1) ? true : false;

  self.hasWinner = function () {
    return self.youBoard.winner || self.oppBoard.winner;
  }

  self.startGame = function () {
    self.nextTurn();
  }

  self.nextTurn = function () {

    self.yourturn = !self.yourturn;

    if (self.yourturn) {
      bs.game.state.start('yourturn');
    } else {
      bs.game.state.start('oppturn');
    }

  }

  self.playWinning = function (wtxt, cb) {
    // winning animation...

    var kaboom = bs.game.add.audio('explode');

    var beog = new bombsEOG(function () {

      if (bs.animOn) {
        var explode = bs.game.add.sprite(bs.game.world.centerX, -60, 'bombsheet');
        explode.anchor.setTo(0.5, 0.5);

        explode.scale.set(12);
        var anim = explode.animations.add('explode', null, 8, false);
      }
      if (bs.audioOn)
        kaboom.play();

      if (bs.audioOn)
        bs.game.time.events.repeat(100, 5, function () {
          kaboom.restart();
        });

      var txt;
      if (bs.animOn) {
        txt = bs.setText(wtxt,
          bs.game.world.centerX, bs.game.world.centerY, 64, 6, 'LightSteelBlue', 'DarkSlateGray');
      } else {
        txt = bs.setText(wtxt,
          bs.game.world.centerX, bs.game.world.centerY, 64, 6, 'Yellow', 'Yellow');

      }

      bs.game.add.tween(txt.scale).from({
          x: 0.01,
          y: 0.01
        }, 2000,
        Phaser.Easing.Exponential.Out, true, 0);

      if (bs.animOn) {
        anim.play();
        anim.onComplete.add(function () {
          txt.destroy();
          cb();
        });
      } else {
        bs.game.time.events.add(Phaser.Timer.SECOND * 2,
          function () {
            txt.destroy();
            cb();
          }
        );
      }


    });

  }

  self.resetGame = function () {
    bs.tsize = 43;
    self.youBoard.ships.length = 0;
    self.oppBoard.ships.length = 0;
    self.youBoard.misses.length = 0;
    self.oppBoard.misses.length = 0;
    self.youBoard.winner = false;
    self.oppBoard.winner = false;

  }

  // two player ==================================

  // is this player one
  self.isP1 = false;

  // does player one go first
  //self.p1first = true;//(Math.round(Math.random())==1)?true:false;

  self.nextTurn2 = function () {
    self.yourturn = !self.yourturn;

    if (self.yourturn) {
      bs.game.state.start('yourturn2');
    } else {
      bs.game.state.start('oppturn2');
    }

  }
}


function aiObj() {
  var self = this;

  self.placeShips = function (ships) {

    var used = [];

    for (var i = 0; i < ships.length; i++) {

      var shipfail = false;

      var ship = ships[i];
      // vert or horz

      var orien = (Math.round(Math.random()) == 1) ? 'v' : 'h';

      //var orien = 'h';

      // line of grid
      // 0 - 9 rows
      var row, col;

      if (orien == 'h') {
        row = Math.floor((Math.random() * 10));
        // 0 - 9 columns less width of ship
        col = Math.floor(Math.random() * (10 - ship.width));
        // position in the line.. accounting for the length of the ship
      } else {
        row = Math.floor((Math.random() * (10 - ship.width)));
        // 0 - 9 columns less width of ship
        col = Math.floor(Math.random() * 10);
        // position in the line.. accounting for the length of the ship

      }
      // upper left pos = 0
      // lower right pos = 99

      var pos = (row * 10) + col;
      // place ship

      var loc;
      var locs = [];

      for (var j = 0; j < ship.width; j++) {

        if (!shipfail) {

          if (orien == 'h') {
            loc = pos + j;
          } else {
            loc = pos + (j * 10);
          }

          //check if location is used.
          for (var k = 0; k < used.length; k++) {
            if (loc == used[k]) {
              shipfail = true;
              break;
            }
          }

          if (!shipfail) {
            locs.push(loc);
          } else {
            // exit to next ship
            break;
          }

        }
      }

      if (!shipfail) {
        ship.locs.length = 0;
        ship.orien = orien;
        // put the location in used locations
        for (var l = 0; l < locs.length; l++) {
          var loc = locs[l];
          used.push(loc);
          ship.locs.push({
            pos: loc,
            hit: false
          });
        }

      } else {
        // try again
        i--;
      }
    }

  }

  self.hits = [];
  self.misscnt = 0;
  self.hitdir = null;

  self.placeBomb = function (board, cb) {

    //var placed = false;
    var place = -1;


    if (self.hits.length > 1 && (!self.hitdir)) {
      // figure out the direction
      var hitdif = Math.abs(self.hits[self.hits.length - 1] -
        self.hits[self.hits.length - 2]);
      self.hitdir = (hitdif > 1) ? 'v' : 'h';

    }



    do {

      // how many hits?
      // if one then hit around it
      // if two then find the direction and
      // hit in that direction .. on both sides
      // .. once hits are done in direction then stop

      // if ship is sunk then stop shooting

      //if (self.hits.length == 1 ){
      if (!self.hitdir && self.hits.length) {

        var lasthit = self.hits[self.hits.length - 1];

        if (self.misscnt == 0) {
          place = lasthit - 10;
          self.misscnt++;
        } else if (self.misscnt == 1) {
          place = lasthit - 1;
          self.misscnt++;
        } else if (self.misscnt == 2) {
          place = lasthit + 10;
          self.misscnt++;
        } else if (self.misscnt == 3) {
          place = lasthit + 1;
          self.misscnt++;
        } else { // no more open
          place = -1;
          self.hits.length = 0;
          self.misscnt = 0;
        }

      } else if (self.hitdir && self.hits.length) {

        var lasthit = self.hits[self.hits.length - 1];

        if (self.misscnt == 0) {
          if (self.hitdir == 'v') {
            place = lasthit - 10;
            self.misscnt++;
          } else {
            place = lasthit - 1;
            self.misscnt++;
          }
        } else if (self.misscnt == 1) {
          if (self.hitdir == 'v') {
            place = lasthit + 10;
            self.misscnt++;
          } else {
            place = lasthit + 1;
            self.misscnt++;
          }
        } else {
          place = -1;
          self.hits.pop();
          self.misscnt = 0;
        }

      } else {

        place = Math.floor((Math.random() * bs.totalPegs));
        self.hits.length = 0;
        self.hitdir = null;

      }

      // check if place has been used as hit or miss

      if (place > -1) {
        if (board.isOccupied(place)) {
          place = -1;

        }
      }
      // a single open spot should not be chosen
      // check if each spot around this place is a miss
      if (place > -1) {
        if (board.isMiss(place - 10) && board.isMiss(place + 10) && board.isMiss(place - 1) && board.isMiss(place + 1)) {

          place = -1;
        }
      }

      //off the board
      if (place > bs.totalPegs - 1) {
        place = -1;

      }


    } while (place <= -1);

    cb(place);

  }

}

var mkrstyle = {
  font: "18px Arial",
  fill: "#ff0044",
  align: "center"
};

var bombObj = function (target, board, cb) {
  var self = this;

  // create random place for bomb origin
  var org = Math.floor((Math.random() * 50));
  //var org = 40;

  var x, y;

  var sunk = true;
  var hit = false;

  if (bs.animOn) {

    if (org <= 9) {
      y = -(bs.tsize * 1);
      x = org * bs.tsize;
    } else if (org <= 24) {
      y = (org - 10) * bs.tsize;
      x = bs.tsize * 11;
    } else if (org <= 34) {
      y = bs.tsize * 15;
      x = (org - 25) * bs.tsize;
    } else {
      y = bs.tsize * (org - 35);
      x = -(bs.tsize * 1);
    }
    // no checking here on where bomb lands.
    // that shoudl be decided before we pass target

    self.sprite = bs.game.add.sprite(x, y, 'bomb');

    //audio
    self.splash = bs.game.add.audio('splash03');
    self.explode = bs.game.add.audio('explode');

    self.sprite.scale.setTo(.6, .6);
    self.sprite.anchor.setTo(0.5, 0.5);
    var bombang = bs.game.physics.arcade.angleBetween(
      self.sprite, target.sprite);

    self.sprite.rotation = bombang;

    var bombtween = bs.game.add.tween(self.sprite).to({
      x: target.sprite.x,
      y: target.sprite.y
    }, 1000, null, false, null, false);

    bombtween.start();

    bs.game.add.tween(self.sprite.scale).to({
      x: 1,
      y: 1
    }, 500).to({
      x: .5,
      y: .5
    }, 500).start();

    self.bombing = true;
    var anim, shipnm;

    bombtween.onComplete.add(function () {
      self.bombing = false;
      self.sprite.kill();

      // hit or miss?
      for (var i = 0; i < board.ships.length; i++) {
        var ship = board.ships[i];
        for (var j = 0; j < ship.locs.length; j++) {
          var loc = ship.locs[j];
          if (loc.pos == target.pos) {
            loc.hit = hit = true;
            shipnm = ship.name;

            // see if ship is sunk...
            for (var k = 0; k < ship.locs.length; k++)
              if (!ship.locs[k].hit)
                sunk = false;

            if (sunk)
              ship.isSunk = true;

            break;
          }
        }
        if (hit)
          break;
      }

      if (!hit) {

        board.misses.push(target.pos);

        var splash = bs.game.add.sprite(
          target.sprite.x, target.sprite.y - 50, 'splasheet');
        splash.anchor.setTo(0.5, 0.5);
        anim = splash.animations.add('splash', null, 20, false);
        sunk = false;
        if (bs.audioOn)
          self.splash.play();

      } else {

        var sparks = bs.game.add.emitter(target.sprite.x, target.sprite.y, 100);

        sparks.makeParticles('spark');
        sparks.gravity = 100;
        sparks.setScale(0.1, 1, 0.1, 1, 2000);
        sparks.setAlpha(1, 0, 6000);
        sparks.setXSpeed(-100, 100);
        sparks.setYSpeed(-200, 10);
        sparks.start(true, 2000, null, 100);
        var explode = bs.game.add.sprite(
          target.sprite.x, target.sprite.y - 30, 'bombsheet');
        explode.anchor.setTo(0.5, 0.5);
        anim = explode.animations.add('explode', null, 20, false);

        if (bs.audioOn)
          self.explode.play();
        // what ship did we hit?
        var shipmkr = bs.game.add.text(target.sprite.x, target.sprite.y, shipnm, mkrstyle);
        shipmkr.anchor.set(0.5);

        bs.game.add.tween(shipmkr).to({
          alpha: 0,
          y: '-100'
        }, 3000, Phaser.Easing.Cubic.Out, true, 500);

      }

      anim.onComplete.add(function () {

        pegObj(target.sprite.x, target.sprite.y, hit);

        bs.game.time.events.add(Phaser.Timer.SECOND,
          function () {
            cb(hit, sunk);
          }
        );

      });

      anim.play();

    });

    self.rocket = bs.game.add.emitter(0, 0, 500);
    self.rocket.makeParticles(['flame1', 'flame2']);
    self.rocket.setRotation(0, 0);
    self.rocket.gravity = 100;
    self.rocket.minParticleSpeed.set(-500, -300);
    self.rocket.maxParticleSpeed.set(-1000, 300);

    self.sprite.addChild(self.rocket);

    self.rocket.x = -130;
    self.rocket.y = -0;
    self.rocket.lifespan = 25;

  } else { // no anim

    // hit or miss?
    for (var i = 0; i < board.ships.length; i++) {
      var ship = board.ships[i];
      for (var j = 0; j < ship.locs.length; j++) {
        var loc = ship.locs[j];
        if (loc.pos == target.pos) {
          loc.hit = hit = true;
          shipnm = ship.name;

          // see if ship is sunk...
          for (var k = 0; k < ship.locs.length; k++)
            if (!ship.locs[k].hit)
              sunk = false;

          if (sunk)
            ship.isSunk = true;
          break;
        }
      }
      if (hit)
        break;
    }
    if (!hit) {
      sunk = false;
      board.misses.push(target.pos);
    } else {
      var shipmkr = bs.game.add.text(target.sprite.x, target.sprite.y - 30, shipnm, {
        font: "18px Arial",
        fill: "yellow",
        align: "center"
      });
      shipmkr.anchor.set(0.5);
    }

    pegObj(target.sprite.x, target.sprite.y, hit);

    bs.game.time.events.add(Phaser.Timer.SECOND * 2,
      function () {
        cb(hit, sunk);
      }
    );

  }


}

function pegObj(x, y, hit) {
  var self = this;
  self.sprite = bs.game.add.sprite(x + 10, y,
    hit ? 'redpeg' : 'whitepeg');
  self.sprite.anchor.setTo(0.5, 0.5);
}

// end of game explosion
var bombsEOG = function (cb) {

  if (!bs.animOn) {
    cb();
    return;
  }

  var bcnt = 20;
  var tcnt = 0;
  var launch = bs.game.add.audio('launch');

  if (bs.audioOn)
    launch.play();

  bs.game.time.events.repeat(100, 10, function () {
    if (bs.audioOn)
      launch.restart();
  });

  var te = bs.game.time.events.repeat(5, bcnt,

    function () {
      // create random place for bomb origin
      var org = Math.floor((Math.random() * 50));
      //var org = 40;

      var x, y;

      if (org <= 9) {
        y = -(bs.tsize * 1);
        x = org * bs.tsize;
      } else if (org <= 24) {
        y = (org - 10) * bs.tsize;
        x = bs.tsize * 11;
      } else if (org <= 34) {
        y = bs.tsize * 15;
        x = (org - 25) * bs.tsize;
      } else {
        y = bs.tsize * (org - 35);
        x = -(bs.tsize * 1);
      }

      var bmb = bs.game.add.sprite(x, y, 'bomb');

      bmb.scale.setTo(.6, .6);
      bmb.anchor.setTo(0.5, 0.5);

      bmb.rotation = bs.game.physics.arcade.angleToXY(
        bmb, bs.game.world.centerX, bs.game.world.centerY);

      var bombtween = bs.game.add.tween(bmb).to({
          x: bs.game.world.centerX,
          y: bs.game.world.centerY
        },
        1000, null, false, null, false);

      bombtween.onComplete.add(function () {
        bmb.kill();
      });

      var rocket = bs.game.add.emitter(0, 0, 500);
      rocket.makeParticles(['flame1', 'flame2']);
      rocket.setRotation(0, 0);
      rocket.gravity = 100;
      rocket.minParticleSpeed.set(-500, -300);
      rocket.maxParticleSpeed.set(-1000, 300);

      bmb.addChild(rocket);

      rocket.x = -130;
      rocket.y = -0;

      if (bs.animOn) {
        bombtween.start();
        rocket.start(false, 25, 1);
      }
      tcnt++;

      if (tcnt == bcnt) {
        bs.game.time.events.add(Phaser.Timer.SECOND,
          function () {
            cb();
          }
        );

      }

    }

  );


}
