bs.gameover = function(){
  var self = this;
  var music;

  self.create = function() {

    bs.tsize = 27;

    var water1 = self.game.add.sprite(0, 0, 'watersheet');
    water1.scale.setTo(0.65,0.65);
    var water2 = self.game.add.sprite(0, bs.tsize*12, 'watersheet');
    water2.scale.setTo(0.65,0.65);

    var map = self.game.add.tilemap('mapsm');
    map.addTilesetImage('levelsm');
    var layer = map.createLayer('Tile Layer 1');
    layer.scale.setTo(1.17,1.17);
    layer.resizeWorld();

    if (bs.play.youBoard.winner)
      self.winnerText(bs.tsize*13, bs.tsize*11)
    else
      self.loserText(bs.tsize*13, bs.tsize*11)

    if (bs.play.oppBoard.winner)
      self.winnerText(bs.tsize*13, bs.tsize*23)
    else
      self.loserText(bs.tsize*13, bs.tsize*23)


    if (bs.isTwoPlay){
      //reverse
      var ob = bs.play.oppBoard;
      var yb = bs.play.youBoard;
      bs.play.oppBoard = yb;
      bs.play.youBoard = ob;
    }


    bs.play.oppBoard.placeShips(0.65,
      {x:bs.tsize*.2,y:-bs.tsize*2.15});
    bs.play.youBoard.placeShips(0.65,
      {x:bs.tsize*.2,y:bs.tsize*9.75});
    bs.play.oppBoard.placePegs(0.65,
      {x:-(bs.tsize*.15),y:-(bs.tsize*2)} );
    bs.play.youBoard.placePegs(0.65,
      {x:-(bs.tsize*.15),y:(bs.tsize*10)} );


    bs.setText('Your Board',bs.tsize*5.25, bs.tsize*11, 26,4,'LightSteelBlue', 'DarkSlateGray');
    bs.setText('Opponent\'s Board',bs.tsize*5.25, bs.tsize*23, 26,4,'LightSteelBlue', 'DarkSlateGray');

    // side board stats - opponents board

    self.labelText('White:', bs.tsize*10.25,
      bs.tsize, 'White','Grey');

    self.labelText('Red:', bs.tsize*10.25,
      bs.tsize*2.5, 'Red','DarkRed');

    self.labelText('Ratio:', bs.tsize*10.25,
      bs.tsize*4, 'LightSteelBlue','DarkSlateGray');

    var ywhite = bs.play.oppBoard.misses.length;

    var yred = 0;

    for (var p=0;p<bs.play.oppBoard.ships.length;p++)
      for (var l=0;l<bs.play.oppBoard.ships[p].locs.length;l++)
        if(bs.play.oppBoard.ships[p].locs[l].hit)
          yred++;

    self.labelText((ywhite), bs.tsize*13.25,
      bs.tsize, 'White','Grey');
    self.labelText((yred), bs.tsize*13.25,
      bs.tsize*2.5, 'Red','DarkRed');

    var r = gcd(yred, ywhite);

    self.labelText((yred/r), bs.tsize*13.25,
      bs.tsize*4, 'Red','DarkRed');
    self.labelText(':', bs.tsize*14.25,
      bs.tsize*4, 'grey','black');
    self.labelText((ywhite/r), bs.tsize*14.75,
      bs.tsize*4, 'LightSteelBlue','DarkSlateGray');


    // side board stats - your board

    self.labelText('White:', bs.tsize*10.25,
      bs.tsize*13, 'White','Grey');

    self.labelText('Red:', bs.tsize*10.25,
      bs.tsize*14.5, 'Red','DarkRed');

    self.labelText('Ratio:', bs.tsize*10.25,
      bs.tsize*16, 'LightSteelBlue','DarkSlateGray');

    var ywhite = bs.play.youBoard.misses.length;

    var yred = 0;

    for (var p=0;p<bs.play.youBoard.ships.length;p++)
      for (var l=0;l<bs.play.youBoard.ships[p].locs.length;l++)
        if(bs.play.youBoard.ships[p].locs[l].hit)
          yred++;

    self.labelText((ywhite), bs.tsize*13.25,
      bs.tsize*13, 'White','Grey');
    self.labelText((yred), bs.tsize*13.25,
      bs.tsize*14.5, 'Red','DarkRed');

    var r = gcd(yred, ywhite);

    self.labelText((yred/r), bs.tsize*13.25,
      bs.tsize*16, 'Red','DarkRed');
    self.labelText(':', bs.tsize*14.25,
      bs.tsize*16, 'grey','black');
    self.labelText((ywhite/r), bs.tsize*14.75,
      bs.tsize*16, 'LightSteelBlue','DarkSlateGray');

    var click02 = self.game.add.audio('click02');

    if (bs.isTwoPlay){
      if (bs.play.youBoard.winner)
        music = self.game.add.audio('sadend');
      else
        music = self.game.add.audio('happyend');
    }else{
      if (bs.play.youBoard.winner)
        music = self.game.add.audio('happyend');
      else
        music = self.game.add.audio('sadend');
    }
    
    if(bs.audioOn)
    music.play('',0,1,true);

    var button = self.game.add.button(
      bs.tsize*13.15, bs.tsize*19.5, 'playagain',
      function(){
        music.stop();
        if(bs.audioOn)
        click02.play();
        bs.play.resetGame();
        if (bs.isTwoPlay){
          //reverse
          var ob = bs.play.oppBoard;
          var yb = bs.play.youBoard;
          bs.play.oppBoard = yb;
          bs.play.youBoard = ob;
          bs.siglr.playerAgain();
          self.game.state.start('getready2');
        }else{
          self.game.state.start('getready');
        }

      },self,0,0,1,0);

    button.anchor.setTo(0.5, 0.5);
    button.scale.setTo(.75,.75);

  } // create

  $( document ).on("oppAgain", function(ev){
    music.stop();
    bs.play.resetGame();
    //reverse
    var ob = bs.play.oppBoard;
    var yb = bs.play.youBoard;
    bs.play.oppBoard = yb;
    bs.play.youBoard = ob;
    self.game.state.start('getready2');
  });

  self.labelText = function(txt, x, y, clr1, clr2){
    var text = bs.game.add.text();
    text.x = x;
    text.y = y;
    text.text = txt;
    //text.anchor.set(0.5, 0.5);
    text.font = 'courier';
    text.align = 'left';
    text.fontWeight = 'bold';
    text.fontSize = 22;
    text.stroke = 'black';
    text.strokeThickness = 2;
    text.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);

    var grd = text.context.createLinearGradient(0, 0, 0, text.height);
    grd.addColorStop(0, clr1);
    grd.addColorStop(1, clr2);
    text.fill = grd;
  }


  self.winnerText = function(x, y){
    var text = bs.game.add.text();
    text.x = x;
    text.y = y;
    text.text = 'WINNER';
    text.anchor.set(0.5, 0.5);
    text.font = 'courier';
    text.align = 'center';
    text.fontWeight = 'bold';
    text.fontSize = 32;
    text.stroke = 'black';
    text.strokeThickness = 4;
    text.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);

    var grd = text.context.createLinearGradient(0, 0, 0, text.height);
    grd.addColorStop(0, 'LightGreen');
    grd.addColorStop(1, 'DarkGreen');
    text.fill = grd;
  }

  self.loserText = function(x, y){
    var text = bs.game.add.text();
    text.x = x;
    text.y = y;
    text.text = 'LOSER';
    text.anchor.set(0.5, 0.5);
    text.font = 'courier';
    text.align = 'center';
    text.fontWeight = 'bold';
    text.fontSize = 32;
    text.stroke = 'black';
    text.strokeThickness = 4;
    text.setShadow(3, 3, 'rgba(0,0,0,0.5)', 5);

    var grd = text.context.createLinearGradient(0, 0, 0, text.height);
    grd.addColorStop(0, 'Red');
    grd.addColorStop(1, 'DarkRed');
    text.fill = grd;
  }

  // ratio
  function gcd (a, b) {
    return (b == 0) ? a : gcd (b, a%b);
  }

};
