bs.getready = function () {
  var self = this;

  var readyButton, readyButtonOn, readyButtonOff;

  var readyOn = false;

  self.create = function () {

    var water = self.game.add.sprite(0, 86, 'watersheet');
    water.animations.add('waves', null, 5, true);
    if(bs.animOn)
    water.animations.play('waves')

    // audio
    var water_sound = self.game.add.audio('water');
    if(bs.audioOn)
    water_sound.play('', 0, 1, true);
    var click02 = self.game.add.audio('click02');

    var map = self.game.add.tilemap('map');
    map.addTilesetImage('level');
    var layer = map.createLayer('Tile Layer 1');
    layer.resizeWorld();

    // add ships to boards...
    // your ships go in the holding area
    var myshp1 = new shipObj('Cruiser', 3, 'ship3sheet', [0, 1, 2, 1, 0, 3, 4, 3]);
    myshp1.setSprite(bs.tsize * 2, bs.tsize * 13, true)

    var myshp2 = new shipObj('Carrier', 5, 'ship5sheet', [0, 1, 2, 1, 0, 3, 4, 3]);
    myshp2.setSprite(bs.tsize * 6, bs.tsize * 13, true)

    var myshp4 = new shipObj('Battleship', 4, 'ship4sheet', [0, 1, 2, 1, 0, 3, 4, 3]);
    myshp4.setSprite(bs.tsize * 2.5, bs.tsize * 14, true)

    var myshp3 = new shipObj('Submarine', 3, 'sub3sheet', [0, 0, 0, 1, 0, 0, 0, 1, 2, 3, 4, 4, 3, 4, 4, 3, 2, 1]);
    myshp3.setSprite(bs.tsize * 6.5, bs.tsize * 14, true)

    var myshp5 = new shipObj('Destroyer', 2, 'ship2sheet', [0, 1, 2, 1, 0, 3, 4, 3]);
    myshp5.orien = 'v';
    myshp5.setSprite(bs.tsize * 9, bs.tsize * 13.5, true)
    myshp5.tweek = true;



    bs.play.youBoard.ships.push(myshp1);
    bs.play.youBoard.ships.push(myshp2);
    bs.play.youBoard.ships.push(myshp3);
    bs.play.youBoard.ships.push(myshp4);
    bs.play.youBoard.ships.push(myshp5);

    // opponent ships get placed by ai

    bs.play.oppBoard.ships.push(new shipObj('Cruiser', 3, 'ship3sheet', [0, 1, 2, 1, 0, 3, 4, 3]));
    bs.play.oppBoard.ships.push(new shipObj('Carrier', 5, 'ship5sheet', [0, 1, 2, 1, 0, 3, 4, 3]));
    bs.play.oppBoard.ships.push(new shipObj('Submarine', 3, 'sub3sheet', [0, 0, 0, 1, 0, 0, 0, 1, 2, 3, 4, 4, 3, 4, 4, 3, 2, 1]));
    bs.play.oppBoard.ships.push(new shipObj('Battleship', 4, 'ship4sheet', [0, 1, 2, 1, 0, 3, 4, 3]));
    bs.play.oppBoard.ships.push(new shipObj('Destroyer', 2, 'ship2sheet', [0, 1, 2, 1, 0, 3, 4, 3]));
    bs.play.ai.placeShips(bs.play.oppBoard.ships);

    bs.setHeader('All boats in the water!');

    // ready button
    readyButton = self.game.add.button(-self.game.world.centerX, 580, 'begin', function () {

      // store location of ships
      for (var i = 0; i < bs.play.youBoard.ships.length; i++) {
        var ship = bs.play.youBoard.ships[i];

        var xy = ship.getFirstXY();

        var x = xy.x;
        var y = xy.y;

        var pos = bs.getPosFromXY(x, y);
        var loc;
        for (var j = 0; j < ship.width; j++) {
          if (ship.orien == 'h') {
            loc = pos + j;
          } else {
            loc = pos + (j * 10);
          }
          ship.locs.push({
            pos: loc,
            hit: false
          });
        }
      }

      water_sound.stop();
    if(bs.audioOn)
      click02.play();

      bs.play.startGame();


    }, self, 0, 0, 1, 0);

    readyButton.anchor.setTo(0.5, 0.5);
    readyButton.scale.setTo(0.9, 0.9);

    readyButtonOn = bs.game.add.tween(readyButton).to({
        x: self.game.world.centerX
      },
      500, Phaser.Easing.Cubic.In, false);
    readyButtonOff = bs.game.add.tween(readyButton).to({
        x: -self.game.world.centerX
      },
      500, Phaser.Easing.Cubic.In, false);

    bs.getOptions(30);

  }

  self.update = function () {
    var ready = true;

    // if one ship intersects another make them red
    // and turn off ready flag

    for (var i = 0; i < bs.play.youBoard.ships.length; i++) {
      var ship1 = bs.play.youBoard.ships[i];

      ship1.sprite.tint = 0xffffff;
      ship1.ready = true;

      for (var j = 0; j < bs.play.youBoard.ships.length; j++) {

        if (i != j) {

          var ship2 = bs.play.youBoard.ships[j];

          if (Phaser.Rectangle.intersects(
              ship1.sprite.getBounds(), ship2.sprite.getBounds())) {
            ready = false;
            ship1.sprite.tint = 0xff0000;
            ship2.sprite.tint = 0xff0000;
            ship1.ready = false;
            //ship2.ready = false;
            ship1.animPause(true);
            ship2.animPause(true);
          }
        }

      }

      if (Phaser.Rectangle.containsRect(ship1.sprite.getBounds(), bs.activeBox)) {
        ship1.animPause(false);
      } else {
        ready = false;
        ship1.animPause(true);
        ship1.ready = false;
      }

    }

    // if (self.game.input.activePointer.isDown)
    //   ready = false;

    if (ready && !readyOn) {
      readyOn = true;
      readyButtonOn.start();
    } else if (!ready && readyOn) {
      readyOn = false;
      readyButtonOff.start();
    }
  }


};
