bs.joinroom = function () {
  var self = this;

  self.create = function () {
      var click02 = bs.game.add.audio('click02');

      var $phaser_game = $('#phaser_game');
      var $join_pane = $('#join_pane');

      $phaser_game.hide();
      $join_pane.show();

      var $contxt = $('#contxt', $join_pane);
      var $room_form = $('#room_form', $join_pane);
      var $goback_butt = $('#goback_butt', $join_pane);
      var $start_butt = $('#start_butt', $join_pane);
      var $game_sel = $('#game_sel', $join_pane);
      var $game_txt = $('#game_txt', $join_pane);
      var $ready_form = $('#ready_form', $join_pane);
      var $wait_form = $('#wait_form', $join_pane);
      var $join_game_butt = $('#join_game_butt', $join_pane);
      var $wait_txt = $('#wait_txt', $join_pane);

      $room_form.hide();
      $wait_form.hide();

      bs.siglr.gethub().then(function (response) {
          self.hubid = response;

          $contxt.hide();
          $room_form.show();
          $ready_form.hide();


          $.get(bs.svrbase + "bs/games/waiting").done(function (data) {
            if (data.length) {
              $ready_form.show();

              $game_txt.text('List of Games Available...');
              for (var i = 0, l = data.length; i < l; i++) {
                var game = data[i];
                $game_sel.append(new Option(game.gname + (game.has_passkey ? ' - private' : ' - open'), game.gname));
              }

            }

          }).fail(function (error) {
            var errmsg = JSON.parse(error.responseText);
            bootbox.alert(errmsg);
          });

          $start_butt.on('click', function () {
            if (bs.audioOn)
              click02.play();
            if (!$game_sel.val()) {
              bootbox.alert('You must select a game!');
            } else {
              self.gname = $game_sel.val();
              var txtval = $game_sel.text();
              var hpk = (txtval.slice(-7) == 'private');

              if (hpk) {
                bootbox.prompt({
                  title: "This Game Requires a Password.",
                  callback: function (passkey) {
                    if (passkey !== null) {
                      bs.siglr.joinGame(self.gname, passkey);
                    }
                  }
                });
              } else {
                bs.siglr.joinGame(self.gname);
              }
            }

          });

        }, // end of connected
        function (error) {
          bootbox.alert(error);
        })


      $goback_butt.on('click', function () {
        if (bs.audioOn)
          click02.play();
        $phaser_game.show();
        $join_pane.hide();
        self.game.state.start('menu');
      });

    } //create

  $(document).on("joinGameDone", function () {
    var $join_pane = $('#join_pane');
    var $room_form = $('#room_form', $join_pane);
    var $wait_form = $('#wait_form', $join_pane);
    var $join_game_butt = $('#join_game_butt', $join_pane);

    bs.play.gname = self.gname;
    bs.play.isP1 = false;

    $room_form.hide();
    $wait_form.show();
    $join_game_butt.hide();

  });

  // this gets called for game joiner
  // originator has accepted the joining of the game
  $(document).on("oppJoined", function () {
    var click02 = bs.game.add.audio('click02');
    var $join_pane = $('#join_pane');
    var $wait_txt = $('#wait_txt', $join_pane);
    var $join_game_butt = $('#join_game_butt', $join_pane);
    var $goback_butt = $('#goback_butt', $join_pane);
    var $phaser_game = $('#phaser_game');
    var $join_pane = $('#join_pane');


    $wait_txt.text('Opponent Has Joined!!');
    $join_game_butt.show();
    $goback_butt.hide();

    $join_game_butt.on('click', function () {
      if (bs.audioOn)
        click02.play();
      $phaser_game.show();
      $join_pane.hide();
      self.game.state.start('getready2');
    });

  });

  $(document).on("gameAdded", function (ev, gname, has_passkey) {
    var $join_pane = $('#join_pane');
    var $ready_form = $('#ready_form', $join_pane);
    var $game_txt = $('#game_txt', $join_pane);
    var $game_sel = $('#game_sel', $join_pane);

    $ready_form.show();
    $game_txt.text('List of Games Available...')
    $game_sel.append(new Option(gname + (has_passkey ? ' - private' : ' - open'), gname));
  });

  $(document).on("gameRemoved", function (ev, gname) {
    var $join_pane = $('#join_pane');
    var $ready_form = $('#ready_form', $join_pane);
    var $game_txt = $('#game_txt', $join_pane);
    var $game_sel = $('#game_sel', $join_pane);

    var gme = $('option:contains(' + gname + ')', $game_sel);
    if (gme)
      gme.remove();

    if (!$('> option', $game_sel).length) {
      $ready_form.hide();
      $game_txt.text('Waiting for Games...')
    }

  });

}
