bs.oppturn2 = function () {
  var self = this;

  var tweening, bomb, target;

  self.create = function () {
      bomb = null;
      target = null;
      tweening = false;

      var water = self.game.add.sprite(0, 86, 'watersheet');
      water.animations.add('waves', null, 5, true);
      if (bs.animOn)
        water.animations.play('waves')

      var map = self.game.add.tilemap('map');
      map.addTilesetImage('level');
      var layer = map.createLayer('Tile Layer 1');
      layer.resizeWorld();

      // battleships text

      bs.setHeader("Opponent's Turn!");

      // place your ships ..

      bs.play.youBoard.placeShips(null, null, false, true);

      // place pegs
      bs.play.youBoard.placePegs();

      bs.getOptions(30);

    } // create

  $(document).on("oppFired", function (ev, x, y) {
    var siren = bs.game.add.audio('siren');
    var launch = bs.game.add.audio('launch');

    var cnt;
    // skip counting if no anim
    if (bs.animOn)
      cnt = 3;
    else
      cnt = 0;

    // sirens
    if (bs.animOn) {
      var siren1 = bs.game.add.sprite(
        bs.tsize * .5, bs.tsize * 13, 'firelight');
      siren1.scale.setTo(0.7, 0.7);
      siren1.animations.add('flash', null, 8, true);

      siren1.animations.play('flash');

      var siren2 = bs.game.add.sprite(
        bs.tsize * 8.75, bs.tsize * 13, 'firelight');
      siren2.scale.setTo(0.7, 0.7);
      siren2.animations.add('flash', null, 8, true);

      bs.game.time.events.add(500,
        function () {
          if (bs.animOn)
            siren2.animations.play('flash');
        }
      );
    }

    target = new targetObj(x, y, true);

    // bs.play.ai.placeBomb(bs.play.youBoard, function(pos){
    //   var xy = bs.getXYFromPos(pos);
    //   target = new targetObj(xy.x, xy.y, true);
    // });

    var timer = bs.game.time.events.loop(Phaser.Timer.SECOND,
      function () {
        if (bs.audioOn)
          siren.play();

        if (cnt > 0) // i need 4 ticks but don't want to print zero
          self.cntxt(cnt, (bs.game.world.width / 4) * (4 - cnt), bs.tsize * 13.5)

        cnt--;
        //ctext.text = cnt
        if (cnt < 0) {
          bs.game.time.events.remove(timer);
          siren.stop();

          if (bs.audioOn)
            launch.play();

          bomb = new bombObj(target, bs.play.youBoard, function (hit, sunk) {

            if (hit) {
              bs.play.ai.hits.push(target.pos);
              bs.play.ai.misscnt = 0;
            }

            if (sunk) {
              bs.play.ai.hits.length = 0;
              bs.play.ai.hitdir = null;
            }


            if (bs.play.youBoard.checkWinner()) {

              bs.play.oppBoard.winner = true;

              // debug only - this normally gets set when there is a real winner
              //bs.play.youBoard.winner = false;

              // opponant has won
              bs.play.playWinning('YOU ARE THE LOSER!!!', function () {
                // go to won state
                bs.game.state.start('gameover');
              });
            } else {
              if (sunk && window.admob && bs.ads_on)
                window.admob.showInterstitialAd();

              bs.play.nextTurn2();

            }
          });

        }
      });


  }); // oppFired




  self.update = function () {
    // flames
    if (bomb && bomb.bombing && bs.animOn) {
      bomb.rocket.emitParticle();
    }
  }

  // counter text
  self.cntxt = function (txt, x, y) {
    var ctext = self.game.add.text(x, y);
    ctext.text = txt
    ctext.anchor.set(0.5);
    ctext.font = 'courier'
    ctext.align = 'center';
    ctext.fontWeight = 'bold';
    ctext.fontSize = 84;
    ctext.stroke = 'black';
    ctext.strokeThickness = 2;
    var cgrd = ctext.context.createLinearGradient(0, 0, 0, ctext.height);
    cgrd.addColorStop(0, 'White');
    cgrd.addColorStop(1, 'DarkSlateGray');
    ctext.fill = 'red';

  }

};
