function siglr(){

  var self = this;

  self.hub = null;
  self.hubid = null;


  self.gethub = function(){
    return new Promise(function(resolve, reject){
      if (!self.hub){

        $.getScript(bs.svrbase+'signalr/hubs').done(function() {

          self.hub = $.connection.gameHub;
          $.connection.hub.logging = false;

          // configure commands to be called from client
          self.startGame = function(gname, passkey){
            self.hub.server.startGame(gname,passkey);
          }
          self.joinGame = function(gname, passkey){
            self.hub.server.joinGame(gname, passkey);
          }
          self.playerStart = function(){
            self.hub.server.playerStart(bs.play.gname);
          }
          // player has setup ships
          self.playerSetBoard = function(ships2p){
            self.hub.server.playerSetBoard(bs.play.gname, ships2p);
          }
          self.starterQuit = function(){
            self.hub.server.starterQuit(bs.play.gname);
          }
          // player one announce they are first or not
          self.anncFirst = function(){
            self.hub.server.anncFirst(bs.play.gname, bs.play.yourturn);
          }
          self.playerFired = function(target){
            var xy = bs.getXYFromPos(target.pos);
            self.hub.server.playerFired(bs.play.gname, xy.x, xy.y);
          }
          self.playerAgain = function(){
            self.hub.server.playerAgain(bs.play.gname);
          }
          // configure events called from the server
          self.hub.client.startGameDone = function () {
            $( document ).trigger( "startGameDone");
          };
          self.hub.client.joinGameDone = function () {
            $( document ).trigger( "joinGameDone");
          };
          self.hub.client.oppJoined = function () {
            $( document ).trigger( "oppJoined");
          };
          self.hub.client.gameAdded = function (gname, has_passkey) {
            $( document ).trigger( "gameAdded", [gname, has_passkey]);
          };
          self.hub.client.gameRemoved = function (gname) {
            $( document ).trigger( "gameRemoved", gname);
          };
          self.hub.client.oppSetBoard = function (ships2p) {
            $( document ).trigger( "oppSetBoard", ships2p);
          };
          // only p2 gets this
          self.hub.client.anncFirstDone = function (isp1first) {
            $( document ).trigger( "anncFirstDone", isp1first);
          };
          self.hub.client.oppFired = function (x, y) {
            $( document ).trigger( "oppFired", [x, y]);
          };
          self.hub.client.oppAgain = function (x, y) {
            $( document ).trigger( "oppAgain");
          };


          self.hub.client.errmsg = function (errmsg) {
            bootbox.alert(errmsg);

          };
          self.hub.client.usermsg = function (errmsg) {
            bootbox.alert(errmsg);        
          };


          // Start the connection.
          $.connection.hub.url = bs.svrbase+"signalr";

          $.connection.hub.start().done(function (data) {
            //console.log(data);
            self.hubid = $.connection.hub.id;
            resolve($.connection.hub.id);
          }).fail(function(error){
            reject(error);
          });

        }).fail(function(error){
          reject("Could not connect to the Server.");
          console.log(error);      
        });

      }else{
        resolve($.connection.hub.id);
      }

    });

  }


}
