bs.yourturn = function () {
  var self = this;

  var bomb;

  self.create = function () {

    var target, ships,
      bombox, bombtxt,
      firebutton, nosign,
      firedrocket;

    var myBitmap = self.game.add.bitmapData(bs.activeBox.width, bs.activeBox.height);

    var grd = myBitmap.context.createLinearGradient(0, 0, 0, bs.activeBox.height);
    grd.addColorStop(0, 'LightSteelBlue');
    grd.addColorStop(1, 'DarkSlateGray');
    myBitmap.context.fillStyle = grd;
    myBitmap.context.fillRect(0, 0, bs.activeBox.width, bs.activeBox.height);
    self.game.add.sprite(0, (bs.tsize * 2), myBitmap);
    
    var rad = self.game.add.sprite(self.game.world.centerX, self.game.world.centerX + (bs.tsize * 2), 'rad1');
    rad.anchor.setTo(0.5, 0.5);
    var radtween = self.game.add.tween(rad).to({
      angle: 360
    }, 2000, Phaser.Easing.Linear.None, false, 0, Number.MAX_VALUE, false);
    
    if(bs.animOn)
      radtween.start();
    
    var map = self.game.add.tilemap('map');
    map.addTilesetImage('level');
    var layer = map.createLayer('Tile Layer 1');
    layer.resizeWorld();

    //bombs
    bombox = self.game.add.sprite(bs.tsize * 12, bs.tsize * 13.5, 'bombox');
    bombox.anchor.setTo(0.5, 0.5);
    bombox.scale.setTo(.9, .9);
    self.game.add.tween(bombox).to({
        x: bs.tsize * 8
      },
      500, Phaser.Easing.Cubic.In, true);
    bombox.inputEnabled = true;
    bombox.events.onInputUp.add(function (s, p) {
      // there's a bug created by using
      // startDrag. this fixes it.
      if (target)
        target.sprite.input.stopDrag(p);

    });

    bombox.events.onInputDown.add(function (s, p) {
      // create target once when clicked in box
      if (!target) {

        target = new targetObj(p.x, p.y, false, function () {

          // when dropped..

          // has target been dragged to active box?

          var targready = false;

          if (Phaser.Rectangle.containsPoint(bs.activeBox,
              target.sprite.body.center))
            targready = !bs.play.oppBoard.isOccupied(target.pos);
          target.ready = targready;

          if (targready) {
            if (!firebutton) {
              // create fire button for the first time as ready
              self.game.add.tween(bombox).to({
                  x: bs.tsize * 12
                },
                500, Phaser.Easing.Cubic.Out, true);
              self.game.add.tween(bombtxt).to({
                  x: -bs.tsize * 3
                },
                500, Phaser.Easing.Cubic.Out, true);

              self.game.add.tween(bombtxt).to({
                  x: -bs.tsize * 3
                },
                500, Phaser.Easing.Cubic.Out, true);

              var fback = self.game.add.sprite(self.game.world.centerX,
                bs.tsize * 13.5, 'lback');
              fback.anchor.setTo(0.5, 0.5);
              fback.scale.setTo(0.5, 0.5);


              firebutton = self.game.add.button(self.game.world.centerX + 5,
                bs.tsize * 13.5, 'launch',
                function () {
                  if (!firedrocket) {
                    firedrocket = true;

                    if (bs.audioOn) {
                      fire.play();
                      launch.play();
                    }

                    bomb = new bombObj(target,
                      bs.play.oppBoard,
                      function (hit) {
                        // when bomb is done .. next turn

                        sub.stop();

                        if (bs.play.oppBoard.checkWinner()) {

                          bs.play.youBoard.winner = true;

                          // you are the winner
                          bs.play.playWinning('YOU ARE THE WINNER!!!', function () {
                            // go to won state
                            bs.game.state.start('gameover');
                          });

                        } else {
                          bs.play.nextTurn();
                        }
                      });
                  }
                }, self, 0, 0, 1, 0);


              firebutton.anchor.setTo(0.5, 0.5);
              firebutton.scale.setTo(0.5, 0.5);

              nosign = self.game.add.sprite(self.game.world.centerX,
                bs.tsize * 16.5, 'nosign');
              nosign.anchor.setTo(0.5, 0.5);
              nosign.scale.setTo(0.4, 0.4);
              nosign.inputEnabled = true;

              self.game.add.tween(firebutton).from({
                  y: bs.tsize * 16.25
                },
                500, Phaser.Easing.Cubic.Out, true);
              self.game.add.tween(fback).from({
                  y: bs.tsize * 16.25
                },
                500, Phaser.Easing.Cubic.Out, true);

              // modify the bounding box for the target
              target.sprite.input.boundsRect = new Phaser.Rectangle(
                bs.activeBox.x, bs.activeBox.y,
                bs.activeBox.width + (bs.tsize * 2),
                bs.activeBox.height + (2 * bs.tsize));

            } else {
              // moved back to good place
              // paint firebutton ready again
              self.game.add.tween(nosign).to({
                  y: bs.tsize * 16.5
                },
                500, Phaser.Easing.Cubic.Out, true);
              target.ready = true;
            }

          } else {
            if (firebutton) {
              // target has been moved to a bad place
              // paint firebutton not ready
              self.game.add.tween(nosign).to({
                  y: bs.tsize * 13.5
                },
                500, Phaser.Easing.Cubic.Out, true);

              target.ready = false;

            }
          }

        });

        // makes the target start dragging right away.
        target.sprite.input.startDrag(p);

      }

    });

    bombtxt = bs.setText('Drag Bomb on the Radar and set your Target!', -bs.tsize * 3, bs.tsize * 13.5, 24, 3, 'LightSteelBlue', 'DarkSlateGray');
    bombtxt.wordWrapWidth = bs.tsize * 5.5;
    self.game.add.tween(bombtxt).to({
        x: bs.tsize * 3.25
      },
      500, Phaser.Easing.Cubic.In, true);

    // battleships text
    bs.setHeader("It's Your Turn!");

    // place ships ..
    bs.play.oppBoard.placeShips(null, null, true, true);

    // place pegs
    bs.play.oppBoard.placePegs();

    //audio

    var sub = bs.game.add.audio('sub');
    if (bs.audioOn)
      sub.play('', 0, 0.25, true);

    var fire = bs.game.add.audio('fire');
    var launch = bs.game.add.audio('launch');

    bs.getOptions(30);
  }


  self.update = function () {
    // flames
    if (bomb && bomb.bombing && bs.animOn) {
      bomb.rocket.emitParticle();
    }
  }

  self.render = function () {
    // self.game.debug.text(bs.play.oppBoard.ships[0].orien, 10,100,'red');
    // self.game.debug.text(bs.play.oppBoard.ships[0].sprite.x, 10,130,'red');
    // self.game.debug.text(bs.play.oppBoard.ships[0].sprite.y, 50,130,'red');
    // self.game.debug.geom(bs.play.oppBoard.ships[0].sprite.getBounds(),'red', false)

  }




};
